#if !defined(FALSE)
#define FALSE	0
#endif
#if !defined(TRUE)
#define TRUE	(!FALSE)
#endif

typedef enum {
  TDB_FIELD_STRING = 0,
  TDB_FIELD_BINARY = 1,
  TDB_FIELD_SINT   = 2,
  TDB_FIELD_UINT   = 3,
  TDB_FIELD_FLOAT  = 4,
} tdb_field_type;

typedef struct {	/* binary read from file */
      unsigned long type;
      unsigned long offset;
      unsigned char name[4];
      unsigned long bits;
} tdb_field;

typedef struct {
  FILE *fd;

  size_t table_data_start;

  struct {
    size_t table;
    size_t field_start;
    size_t data_start;
    size_t cursor_record;

    struct {	/* binary read from file */
      unsigned long UNKNOWN_1;
      unsigned long record_length_bytes;
      unsigned long record_length_bits;
      unsigned long UNKNOWN_2;
      unsigned short records_allocated;    
      unsigned short records_used;
      unsigned long UNKNOWN_3;
      unsigned char field_count;
      unsigned char index_count;
      unsigned short UNKNOWN_4;
      unsigned long UNKNOWN_5;
      unsigned long crc;
    } header;

    tdb_field *fields;

    unsigned long data_crc;
  } current;

  struct {
    const char name[4];
    unsigned long offset;
  } *tables;

  size_t table_count;
} tdb_t;

tdb_t *tdb_open(const char *filename, const char *filemode);
int tdb_close(tdb_t *handle);
int tdb_open_table(tdb_t *handle, const char *table_name);
int tdb_seek(tdb_t *handle, long offset, int whence);
long tdb_search(tdb_t *handle, const char *field, void *value);
int tdb_write(tdb_t *handle, const char *field, void *value);
int tdb_get_fields(tdb_t *handle, char *fields[]);
int tdb_close_table(tdb_t *handle);
